Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Index.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Index.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Index.java	(revision 8313)
@@ -30,5 +30,8 @@
 import org.greenstone.gatherer.DebugStream;
 import org.greenstone.gatherer.Gatherer;
-import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataSet;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
+import org.greenstone.gatherer.metadata.MetadataTools;
 import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
@@ -73,10 +76,10 @@
 	    Element content_element = document.createElement(CollectionConfiguration.CONTENT_ELEMENT);
 	    Object source_object = sources.get(i);
-	    if(source_object instanceof ElementWrapper) {
-		///DebugStream.println("Found ElementWrapper as source: " + ((ElementWrapper)source_object).getName());
-		content_element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, ((ElementWrapper)source_object).getName());
+	    if (source_object instanceof MetadataElement) {
+		// System.err.println("Constructing new Index with MetadataElement source...");
+		content_element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, ((MetadataElement) source_object).getFullName());
 	    }
 	    else {
-		///DebugStream.println("Found String as source: " + source_object.toString());
+		// System.err.println("Constructing new Index with String source...");
 		content_element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, source_object.toString());
 	    }
@@ -166,7 +169,6 @@
 	    for(int i = 0; i < sources_size; i++) {
 		Object source_object = sources.get(i);
-		// If its an element wrapper use the unique name rather than the 
-		if(source_object instanceof ElementWrapper) {
-		    String full_element_name = ((ElementWrapper)source_object).getName();
+		if (source_object instanceof MetadataElement) {
+		    String full_element_name = ((MetadataElement)source_object).getFullName();
 		    if(full_element_name.startsWith(StaticStrings.EXTRACTED_NAMESPACE)) {
 		       id_buffer.append(full_element_name.substring(StaticStrings.EXTRACTED_NAMESPACE.length()));
@@ -206,11 +208,11 @@
 	    for(int i = 0; i < content_elements_length; i++) {
 		Element content_element = (Element) content_elements.item(i);
-		String source_str = (String) content_element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
-		ElementWrapper element_wrapper = Gatherer.c_man.getCollection().msm.getElement(source_str);
-		if(element_wrapper != null) {
-		    sources.add(element_wrapper);
+		String metadata_element_name_full = (String) content_element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE);
+		MetadataElement metadata_element = MetadataTools.getMetadataElementWithDisplayName(metadata_element_name_full);
+		if (metadata_element != null) {
+		    sources.add(metadata_element);
 		}
 		else {
-		    sources.add(source_str);
+		    sources.add(metadata_element_name_full);
 		}
 	    }
@@ -267,7 +269,6 @@
 		Element content_element = element.getOwnerDocument().createElement(CollectionConfiguration.CONTENT_ELEMENT);
 		Object source_object = sources.get(i);
-		if(source_object instanceof ElementWrapper) {
-		    //DebugStream.println("Found ElementWrapper as source: " + ((ElementWrapper)source_object).getName());
-		    String name = ((ElementWrapper)source_object).getName();
+		if (source_object instanceof MetadataElement) {
+		    String name = ((MetadataElement) source_object).getFullName();
 		    content_element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, name);
 		    name = null;
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/IndexManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/IndexManager.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/IndexManager.java	(revision 8313)
@@ -39,5 +39,6 @@
 import org.greenstone.gatherer.gui.GComboBox;
 import org.greenstone.gatherer.gui.GLIButton;
-import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
 import org.greenstone.gatherer.util.ExclusiveListSelectionListener;
 import org.greenstone.gatherer.util.StaticStrings;
@@ -383,6 +384,6 @@
 			Object source_object = sources_list.get(j);
 			String source_str = null;
-			if(source_object instanceof ElementWrapper) {
-			    source_str = ((ElementWrapper)source_object).getName();
+			if(source_object instanceof MetadataElement) {
+			    source_str = ((MetadataElement) source_object).getFullName();
 			}
 			else {
@@ -519,6 +520,5 @@
 	    ArrayList new_data = new ArrayList();
 	    new_data.add(CollectionConfiguration.TEXT_STR);
-	    new_data.addAll(Gatherer.c_man.getCollection().msm.getAssignedElements());
-
+	    new_data.addAll(MetadataSetManager.getEveryMetadataSetElement());
 	    // Creation
 	    JPanel mgindexes_panel = new JPanel();
@@ -688,5 +688,5 @@
 		ArrayList new_data = new ArrayList();
 		new_data.add(CollectionConfiguration.TEXT_STR);
-		new_data.addAll(Gatherer.c_man.getCollection().msm.getAssignedElements());
+		new_data.addAll(MetadataSetManager.getEveryMetadataSetElement());
 		// reset the model in the list and combobox
 		source_list.setListData(new_data.toArray());
@@ -772,5 +772,10 @@
 	     * @param event A <strong>ListSelectionEvent</strong> containing further information about the list selection.
 	     */
-	    public void valueChanged(ListSelectionEvent event) {
+	    public void valueChanged(ListSelectionEvent event)
+	    {
+		if (event.getValueIsAdjusting()) {
+		    return;
+		}
+
 		Object value = index_list.getSelectedValue();
 		move_down_button.setEnabled(value != null);
@@ -1200,10 +1205,8 @@
 	    index_combobox.addItem(CollectionConfiguration.METADATA_STR);
 	    index_combobox.addItem(CollectionConfiguration.TEXT_STR);
-	    java.util.List assigned_elements = Gatherer.c_man.getCollection().msm.getAssignedElements();
-	    int assigned_elements_size = assigned_elements.size();
-	    for(int i = 0; i < assigned_elements_size; i++) {
-		index_combobox.addItem(assigned_elements.get(i));
-	    }
-	    assigned_elements = null;
+	    ArrayList every_metadata_set_element = MetadataSetManager.getEveryMetadataSetElement();
+	    for(int i = 0; i < every_metadata_set_element.size(); i++) {
+		index_combobox.addItem(every_metadata_set_element.get(i));
+	    }
 	    // Ensure the level manager has at least documents assigned
 	    if(levels_model.getSize() == 0) {
@@ -1383,6 +1386,6 @@
 		    // Unfortunately we have to generate a valid id
 		    String id = null;
-		    if(selected_object instanceof ElementWrapper) {
-			id = ((ElementWrapper)selected_object).getName();
+		    if (selected_object instanceof MetadataElement) {
+			id = ((MetadataElement) selected_object).getFullName();
 		    }
 		    else {
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/MetadataSetView.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/MetadataSetView.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/MetadataSetView.java	(revision 8313)
@@ -29,7 +29,9 @@
 import java.awt.*;
 import java.awt.event.*;
+import java.io.File;
 import java.util.*;
 import javax.swing.*;
 import javax.swing.event.*;
+import javax.swing.filechooser.*;
 import org.greenstone.gatherer.Configuration;
 import org.greenstone.gatherer.DebugStream;
@@ -37,9 +39,12 @@
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.gui.GLIButton;
-import org.greenstone.gatherer.mem.MetadataEditorManager;
-import org.greenstone.gatherer.msm.MetadataSet;
-import org.greenstone.gatherer.msm.MSMEvent;
-import org.greenstone.gatherer.msm.MSMListener;
-import org.w3c.dom.*;
+import org.greenstone.gatherer.gui.MetadataElementListCellRenderer;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataSet;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
+import org.greenstone.gatherer.metadata.MetadataTools;
+import org.greenstone.gatherer.metadata.MetadataXMLFileManager;
+import org.greenstone.gatherer.util.Utility;
+
 
 /** This class only knows how to produce a simple visual representation of the currently imported metadata sets. It is also read-only, so should be fairly straight forward.
@@ -48,6 +53,6 @@
  */
 public class MetadataSetView
-    extends DynamicListModel
-    implements MSMListener {
+    extends DynamicListModel {
+
     /** The visual contols used to review the metadata sets. */
     private Control controls = null;
@@ -55,38 +60,26 @@
     private DynamicListModel model = null;
 
-    /** Constructor.
-     */
-    public MetadataSetView() {
-	DebugStream.println("MetadataSetView: Initialized.");
+
+    public MetadataSetView()
+    {
 	model = this;
-	Gatherer.c_man.getCollection().msm.addMSMListener(this);
-	loadMetadataSets();
+
+	// Initialise the model
+	refreshModel();
+
 	// Build the controls
-	controls = new MetadataSetControl();
-    }
-
-    /** Destructor. Remove any references of this class from persistant objects.
-     * @see org.greenstone.gatherer.Gatherer
-     * @see org.greenstone.gatherer.collection.CollectionManager
-     */
-    public void destroy() {
+	controls = new MetadataSetViewControls();
+    }
+
+
+    public void destroy()
+    {
 	controls.destroy();
 	controls = null;
-	Gatherer.c_man.msm.removeMSMListener(this);
 	model = null;
     }
 
-    /** Called when an element is changed within a set in the MSM, prompting us to refresh our list of elements being shown.
-     * @param event A <strong>MSMEvent</strong> which encapsulates relevant data about the change.
-     * @see org.greenstone.gatherer.cdm.MetadataSetView.MetadataSetControl
-     */
-    public void elementChanged(MSMEvent event) {
-	// Get the controls to refresh element list.
-	((MetadataSetControl)controls).refreshElementList();
-    }
 
     /** A method for retrieve the controls for this manager.
-     * @see org.greenstone.gatherer.Dictionary
-     * @see org.greenstone.gatherer.gui.Coloring
      */
     public Control getControls() {
@@ -94,64 +87,43 @@
     }
 
-    /** Called when a metadata value has undergone significant change.
-     * @param event A <strong>MSMEvent</strong> which encapsulates relevant data about the change.
-     */
-    public void metadataChanged(MSMEvent event) {
-	// Couldn't care less.
-    }
-
-    /** Called when a set is added or removed from the MSM.
-     * @param event A <strong>MSMEvent</strong> which encapsulates relevant data about the change.
-     */
-    public void setChanged(MSMEvent event) {
-	// Reload model.
-	clear();
-	loadMetadataSets();
-    }
-
-
-    /** Prints out the contents of this manager, as they would appear in the collection configuration file.
-     * @return A <strong>String</strong> containing a block of commands.
-     * @see org.greenstone.gatherer.cdm.MetadataSetView.SetWrapper
-     */
-    public String toString() {
-	String text = "";
-	for(int i = 0; i < size(); i++) {
-	    SetWrapper set = (SetWrapper)get(i);
-	    text = text + set.toString() + "\n";
-	}
-	text = text + "\n";
-	return text;
-    }
-
-    /** Called when a significant change has occured to a value tree for a certain element, however we take no further action.
-     * @param event A <strong>MSMEvent</strong> containing information relevant to the event.
-     */
-    public void valueChanged(MSMEvent event) {
-    }
-
-    /** Retrieves the current list of loaded metadata sets, and builds a list model around them.
-     * @see org.greenstone.gatherer.Gatherer
-     * @see org.greenstone.gatherer.cdm.MetadataSetView.SetWrapper
-     * @see org.greenstone.gatherer.collection.CollectionManager
-     */
-    private void loadMetadataSets() {
-	// We initialize the set_model with wrapped metadata sets. Note that when we call getSets() we also end up adding ourselves as a listener to the metadata set manager.
-	Vector sets = Gatherer.c_man.getCollection().msm.getSets();
-	for(int i = 0; i < sets.size(); i++) {
-	    addElement(new SetWrapper((MetadataSet)sets.get(i)));
-	}
-    }
+
+    public void refreshModel()
+    {
+	// Remove any metadata sets from the model that are no longer loaded
+	ArrayList loaded_metadata_sets = MetadataSetManager.getMetadataSets();
+	for (int i = size() - 1; i >= 0; i--) {
+	    MetadataSet metadata_set = (MetadataSet) get(i);
+	    if (loaded_metadata_sets.contains(metadata_set) == false) {
+		// System.err.println("Metadata set in list no longer loaded...removing.");
+		remove(i);
+	    }
+	}
+
+	// Add any metadata sets that are loaded but not in the model
+	for (int i = 0; i < loaded_metadata_sets.size(); i++) {
+	    MetadataSet loaded_metadata_set = (MetadataSet) loaded_metadata_sets.get(i);
+	    boolean in_model = false;
+	    for (int j = 0; j < size(); j++) {
+		MetadataSet metadata_set = (MetadataSet) get(j);
+		if (metadata_set.equals(loaded_metadata_set)) {
+		    in_model = true;
+		    break;
+		}
+	    }
+
+	    if (in_model == false) {
+		// System.err.println("Metadata set loaded but not in list...adding.");
+		addElement(loaded_metadata_set);
+	    }
+	}
+    }
+
 
     /** This class creates and lays-out the various controls for reviewing the metadata sets, and their commands as they would appear in the collection configuration file. */
-    private class MetadataSetControl
+    private class MetadataSetViewControls
 	extends JPanel
 	implements Control {
-	/** Listens for clicks upon the configure button, or double clicks from the metadata set list. */
-	private ConfigureActionListener configure_action_listener;
 	/** Opens the MEM and systematically performs as if the add set button were clicked. */
 	private JButton add_button;
-	/** Opens the MEM with the appropriate set open for editing. */
-	private JButton configure_button;
 	/** Opens the MEM and systematically performs as if the remove set button were clicked. */
 	private JButton remove_button;
@@ -179,10 +151,6 @@
 	private JTextArea instructions = null;
 
-	private ListListener list_listener;
-
-	private MultilingualListCellRenderer element_list_cell_renderer;
-
-	/** The element model for the currently selected set. */
-	private Vector element_model = null;
+	private MetadataElementListCellRenderer element_list_cell_renderer;
+	private MetadataSetListSelectionListener list_listener;
 
 	/* Constructor.
@@ -191,5 +159,6 @@
 	 * @see org.greenstone.gatherer.cdm.MetadataSetView.ListListener
 	 */
-	public MetadataSetControl() {
+	public MetadataSetViewControls()
+	{
 	    // Create visual components
 	    central_pane = new JPanel();
@@ -198,8 +167,8 @@
 	    element_label.setOpaque(true);
 	    Dictionary.registerText(element_label, "CDM.MetadataSetManager.Elements");
+	    element_list = new JList();
 	    element_list_scroll_pane = new JScrollPane();
-	    element_list_cell_renderer = new MultilingualListCellRenderer(element_list_scroll_pane);
-	    element_list = new JList();
 	    element_list_scroll_pane.setViewportView(element_list);
+	    element_list_cell_renderer = new MetadataElementListCellRenderer();
 	    element_list.setCellRenderer(element_list_cell_renderer);
 	    element_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
@@ -218,8 +187,6 @@
 	    Dictionary.registerText(set_label, "CDM.MetadataSetManager.Sets");
 	    set_list = new JList(model);
+	    set_list.setCellRenderer(new MetadataSetListCellRenderer());
 	    set_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
-	    if(model.size() > 0) {
-		set_list.setSelectedIndex(0);
-	    }
 
 	    set_pane = new JPanel();
@@ -234,21 +201,14 @@
 	    add_button.setMnemonic(KeyEvent.VK_A);
 	    Dictionary.registerBoth(add_button, "CDM.MetadataSetManager.Add", "CDM.MetadataSetManager.Add_Tooltip");
-	    configure_button = new GLIButton();
-	    configure_button.setEnabled(false);
-	    configure_button.setMnemonic(KeyEvent.VK_C);
-	    Dictionary.registerBoth(configure_button, "CDM.MetadataSetManager.Configure", "CDM.MetadataSetManager.Configure_Tooltip");
 	    remove_button = new GLIButton();
 	    remove_button.setEnabled(false);
 	    remove_button.setMnemonic(KeyEvent.VK_R);
 	    Dictionary.registerBoth(remove_button, "CDM.MetadataSetManager.Remove", "CDM.MetadataSetManager.Remove_Tooltip");
-	    configure_action_listener = new ConfigureActionListener();
-	    list_listener = new ListListener();
+	    list_listener = new MetadataSetListSelectionListener();
 
 	    // Add listeners
 	    add_button.addActionListener(new AddButtonListener());
-	    configure_button.addActionListener(configure_action_listener);
 	    remove_button.addActionListener(new RemoveButtonListener());
 	    set_list.addListSelectionListener(list_listener);
-	    set_list.addMouseListener(configure_action_listener);
 	    // Layout
 	    instructions.setBorder(BorderFactory.createEmptyBorder(2,5,2,5));
@@ -273,5 +233,4 @@
 	    button_pane.setLayout(new GridLayout(1,3,0,0));
 	    button_pane.add(add_button);
-	    button_pane.add(configure_button);
 	    button_pane.add(remove_button);
 
@@ -282,20 +241,18 @@
 	    add(button_pane, BorderLayout.SOUTH);
 	}
-	/** Destructor. */
-	public void destroy() {
-	}
-	/** Update the element list. */
-	public void refreshElementList() {
-	    element_list.updateUI();
-	}
-
-	/** Overriden to ensure the instruction area is scrolled to top.
-	 */
-	public void gainFocus() {
-	    if(instructions != null) {
+
+
+	public void destroy() { }
+
+
+	public void gainFocus()
+	{
+	    // Ensure the instructions area is scrolled to the top
+	    if (instructions != null) {
 		instructions.setCaretPosition(0);
 	    }
+
 	    // If no current selection, select first available set
-	    if(set_list.isSelectionEmpty() && set_list.getModel().getSize() > 0) {
+	    if (set_list.isSelectionEmpty() && set_list.getModel().getSize() > 0) {
 		set_list.setSelectedIndex(0);
 		list_listener.valueChanged(new ListSelectionEvent(set_list, 0, 0, true));
@@ -303,185 +260,98 @@
 	}
 
-	public void loseFocus() {
-	}
-
-	/** Listens for clicks on the add button, and actions them accordingly by opening the MEM and clicking add set. */
+
+	public void loseFocus() { }
+
+
+	/** Listens for clicks on the add button. */
 	private class AddButtonListener
 	    implements ActionListener {
+
 	    /** Called when the add button is clicked.
 	     * @param event an ActionEvent containing information about the mouse click
-	     * @see org.greenstone.gatherer.Gatherer
-	     * @see org.greenstone.gatherer.collection.Collection
-	     * @see org.greenstone.gatherer.collection.CollectionManager
-	     * @see org.greenstone.gatherer.mem.MetadataEditorManager
 	     */
-	    public void actionPerformed(ActionEvent event) {
-		Gatherer.c_man.getCollection().msm.editMDS(null, MetadataEditorManager.ADD_SET);
-	    }
-	}
-
-	/** Listens for clicks on the configure button or double clicks upon the metadata set list and chains to the MEM as appropriate. */
-	private class ConfigureActionListener
-	    extends MouseAdapter 
+	    public void actionPerformed(ActionEvent event)
+	    {
+		JFileChooser chooser = new JFileChooser(new File(Utility.METADATA_DIR));
+		chooser.setFileFilter(new MetadataSet.MetadataSetFileFilter());
+		int return_val = chooser.showDialog(Gatherer.g_man, Dictionary.get("MSMPrompt.File_Import"));
+		if (return_val == JFileChooser.APPROVE_OPTION) {
+		    Gatherer.c_man.importMetadataSet(new MetadataSet(chooser.getSelectedFile()));
+		    refreshModel();
+
+		    // The metadata.xml files may possibly contain metadata for this newly added metadata set
+		    // Re-read all the metadata.xml files to account for this case
+		    MetadataXMLFileManager.clearMetadataXMLFiles();
+		    MetadataXMLFileManager.loadMetadataXMLFiles(new File(Gatherer.c_man.getCollectionImport()));
+		}
+	    }
+	}
+
+
+	private class MetadataSetListCellRenderer
+	    implements ListCellRenderer
+	{
+	    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
+	    {
+		DefaultListCellRenderer default_list_cell_renderer = new DefaultListCellRenderer();
+		JLabel list_cell_label = (JLabel) default_list_cell_renderer.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
+
+		if (value instanceof MetadataSet) {
+		    MetadataSet metadata_set = (MetadataSet) value;
+		    String metadata_set_name = MetadataTools.getMetadataSetAttribute(metadata_set, "Name", Configuration.getLanguage(), "en");
+		    list_cell_label.setText("metadataset " + metadata_set.getNamespace() + " \"" + metadata_set_name + "\"");
+		}
+
+		return list_cell_label;
+	    }
+	}
+
+
+	private class MetadataSetListSelectionListener
+	    implements ListSelectionListener {
+
+	    public void valueChanged(ListSelectionEvent event)
+	    {
+		// Wait until we get a stable event
+		if (event.getValueIsAdjusting()) {
+		    return;
+		}
+
+		// Now we can process it
+		if (!set_list.isSelectionEmpty()) {
+		    MetadataSet metadata_set = (MetadataSet) set_list.getSelectedValue();
+		    element_list.setListData(new Vector(metadata_set.getMetadataSetElements()));
+  		    remove_button.setEnabled(true);
+
+  		    // Finally check the directionality and scroll as necessary
+  		    JScrollBar scroll_bar = element_list_scroll_pane.getHorizontalScrollBar();
+  		    if (element_list_cell_renderer.getDirectionality() == Character.DIRECTIONALITY_RIGHT_TO_LEFT) {
+			scroll_bar.setValue(scroll_bar.getMaximum());
+  		    }
+  		    else {
+			scroll_bar.setValue(scroll_bar.getMinimum());
+		    }
+		}
+		else {
+		    remove_button.setEnabled(false);
+		}
+	    }
+	}
+
+
+	/** Listens for clicks on the remove button. */
+	private class RemoveButtonListener
 	    implements ActionListener {
-	    /** Called when the configure button is clicked.
+
+	    /** Called when the remove button is clicked.
 	     * @param event an ActionEvent containing information about the mouse click
 	     */
-	    public void actionPerformed(ActionEvent event) {
-		configureSet();
-	    }
-
-	    /** Called whenever the mouse is clicked over a registered component, we use this to chain through to the configure prompt.
-	     * @param event a MouseEvent containing information about the mouse click
-	    */
-	    public void mouseClicked(MouseEvent event) {
-		if(event.getClickCount() == 2 ) {
-		    configureSet();
-		}
-	    }
-	    /** If some set is selected, then open the metadata set manager with the current set selected and expanded 
-	     * @see org.greenstone.gatherer.Gatherer
-	     * @see org.greenstone.gatherer.collection.Collection
-	     * @see org.greenstone.gatherer.collection.CollectionManager
-	     * @see org.greenstone.gatherer.cdm.MetadataSetView.SetWrapper
-	     * @see org.greenstone.gatherer.mem.MetadataEditorManager
-	     */
-	    private void configureSet() {
-		if(!set_list.isSelectionEmpty()) {
-		    MetadataSet set = ((SetWrapper)set_list.getSelectedValue()).getSet();
-		    Gatherer.c_man.getCollection().msm.editMDS(set, MetadataEditorManager.NORMAL);
-		}
-		else {
-		    configure_button.setEnabled(false);
-		}
-	    }
-	}
-
-	private class ListListener
-	    implements ListSelectionListener {
-	    public void valueChanged(ListSelectionEvent event) {
-		// Wait until we get a stable event
-		if(event.getValueIsAdjusting()) {
-		    return;
-		}
-		// Now we can process it
-		if(!set_list.isSelectionEmpty()) {
-		    MetadataSet set = ((SetWrapper)set_list.getSelectedValue()).getSet();
-		    NodeList elements = set.getElements();
-		    element_model = new Vector();
-		    for(int i = 0; i < elements.getLength(); i++) {
-			element_model.add(new ElementWrapper(elements.item(i)));
-		    }
-		    //Collections.sort(element_model);
-		    element_list.setListData(element_model);
-		    configure_button.setEnabled(true);
-		    remove_button.setEnabled(true);
-
-		    // Finally check the directionality and scroll as necessary
-		    JScrollBar scroll_bar = element_list_scroll_pane.getHorizontalScrollBar();
-		    if(element_list_cell_renderer.getDirectionality() == Character.DIRECTIONALITY_RIGHT_TO_LEFT) {
-			scroll_bar.setValue(scroll_bar.getMaximum());
-		    }
-		    else {
-			scroll_bar.setValue(scroll_bar.getMinimum());
-		    }
-
-		}
-		else {
-		    configure_button.setEnabled(false);
-		    remove_button.setEnabled(false);
-		}
-	    }
-	}
-
-	/** Listens for clicks on the remove button, and actions them accordingly by opening the MEM and clicking remove set. */
-	private class RemoveButtonListener
-	    implements ActionListener {
-	    /** Called when the remove button is clicked.
-	     * @param event an ActionEvent containing information about the mouse click
-	     * @see org.greenstone.gatherer.Gatherer
-	     * @see org.greenstone.gatherer.collection.Collection
-	     * @see org.greenstone.gatherer.collection.CollectionManager
-	     * @see org.greenstone.gatherer.cdm.MetadataSetView.SetWrapper
-	     * @see org.greenstone.gatherer.mem.MetadataEditorManager
-	     */
-	    public void actionPerformed(ActionEvent event) {
-		if(!set_list.isSelectionEmpty()) {
-		    MetadataSet set = ((SetWrapper)set_list.getSelectedValue()).getSet();
-		    Gatherer.c_man.getCollection().msm.editMDS(set, MetadataEditorManager.REMOVE_SET);
-		}
-		else {
-		    remove_button.setEnabled(false);
-		}
-	    }
-	}
-
-	private class MultilingualListCellRenderer
-	    extends DefaultListCellRenderer {
-	    private byte previous_directionality = Character.DIRECTIONALITY_UNDEFINED;
-	    private JScrollPane scroll_pane;
-	    public MultilingualListCellRenderer(JScrollPane scroll_pane) {
-		super();
-		this.scroll_pane = scroll_pane;
-	    }
-
-	    public byte getDirectionality() {
-		if(previous_directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT || previous_directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT_ARABIC || previous_directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT_EMBEDDING || previous_directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT_OVERRIDE) {
-		    return Character.DIRECTIONALITY_RIGHT_TO_LEFT;
-		}
-		else {
-		    return Character.DIRECTIONALITY_LEFT_TO_RIGHT;
-		}
-	    }
-	    
-	    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
-		JLabel component = (JLabel) super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
-		// Determine if the text should be left aligned or right aligned
-		String text = value.toString();
-		int text_index = 0;
-		byte directionality = Character.DIRECTIONALITY_UNDEFINED;
-		while(directionality == Character.DIRECTIONALITY_UNDEFINED && text_index < text.length()) {
-		    directionality = Character.getDirectionality(text.charAt(text_index));
-		    text_index++;
-		}
-		if(directionality != previous_directionality) {
-		    previous_directionality = directionality;
-		    if(directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT || directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT_ARABIC || directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT_EMBEDDING || directionality == Character.DIRECTIONALITY_RIGHT_TO_LEFT_OVERRIDE) {
-			///ystem.err.println("R2L for: " + text);
-			component.setHorizontalAlignment(JLabel.TRAILING);
-			component.setHorizontalTextPosition(JLabel.TRAILING);
-			component.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
-			//scroll_pane.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
-		    }
-		    else {
-			component.setHorizontalAlignment(JLabel.LEADING);
-			component.setHorizontalTextPosition(JLabel.LEADING);
-			///ystem.err.println("L2R for: " + text);
-			component.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
-			//scroll_pane.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
-		    }
-		}
-
-		text = null;
-		return component;
-	    }
-
-	}
-	
-    }
-
-    /** Provides a convience wrapper around a metadata set, that allows it to appear in the <strong>JList</strong> the same way it would in the collection configuration file. */
-    private class SetWrapper {
-	private MetadataSet set = null;
-	public SetWrapper(MetadataSet set) {
-	    this.set = set;
-	}
-	public MetadataSet getSet() {
-	    return set;
-	}
-	public String toString() {
-	    String namespace = set.getNamespace();
-	    // Watch out for the greenstone set, with its namespace of ""
-	    return "metadataset " + namespace + " \"" + set.getName() + "\"";
+	    public void actionPerformed(ActionEvent event)
+	    {
+		MetadataSet metadata_set = (MetadataSet) set_list.getSelectedValue();
+		Gatherer.c_man.removeMetadataSet(metadata_set);
+		refreshModel();
+		element_list.setListData(new Vector());
+	    }
 	}
     }
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Subcollection.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Subcollection.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Subcollection.java	(revision 8313)
@@ -28,5 +28,4 @@
 
 import org.greenstone.gatherer.Gatherer;
-import org.greenstone.gatherer.msm.ElementWrapper;
 import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Troolean;
@@ -154,15 +153,10 @@
      * @return a String which is either the fully qualified name of a metadata element, or filename
      */
-    public String getSource() {
-	if(source == null &&element != null) {
+    public String getSource()
+    {
+	if (source == null && element != null) {
 	    source = element.getAttribute(StaticStrings.CONTENT_ATTRIBUTE);
-	    // If this is a metadata element then retrieve the appropriate ElementWrapper and use the language specific name
-	    if(!source.equals(StaticStrings.FILENAME_STR)) {
-		ElementWrapper element_wrapper = Gatherer.c_man.getCollection().msm.getElement(source);
-		if(element_wrapper != null) {
-		    source = element_wrapper.toString();
-		}
-	    }
-	}
+	}
+
 	return source;
     }
